#!/nfs/public/bin/sybperl
#
# Program:  daysopen.pl      Description:  Display all open tickets, starting 
#                                          with oldest first, and give links
#                                          to get the status of each ticket.
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 07/07/96   Version: 2.00

require "helpdesk.inc";

#########################################################################
#  Execute query and calculate number of days open for assigned tickets
#########################################################################

&helpdesk_login;
$totday=0;
$tabrow=0;
&startup;
$dbproc = &dblogin("$opt_u", $pw, $opt_s);
&dbuse($dbproc, $opt_d);
&dbuse ($opt_d);
$str="
select ticketId, days=datediff(day, submitDate, getdate()), assigned, submitLastName, priority
       from OTicket where status = \"A\" or status = \"U\"";
&dbcmd($dbproc, $str);
&dbresults($dbproc);
&dbsqlexec ($dbproc);
if(&dbresults($dbproc)==&SUCCEED) {
  while(@data=&dbnextrow($dbproc)) {
    &do_point(@data);
  }
}
print "</table>\n";
printf "<br><br><font size=+2>Totals:  Open/Unassigned Tickets: %d   Average Days Open: %d</font>", $tabrow, $totday/$tabrow; 
print "</html>\n";
exit;

#################################
#  Do the isql query
#################################

sub do_isql
{
   &dbcmd($dbproc, $str);
   if (&dbsqlexec ($dbproc) !=&SUCCEED)
   {
      print "Error executing command\n";
   }
   &dbresults($dbproc);
}

######################################
#  Setup html code
######################################

sub do_point {
  @tmp=@_;
  printf "<tr><td><a href=\"hdstatus.pl?ticknum=%d\">%5.5d</a></td><td>%3.3d</td><td>%s</td><td>%s</td><td>%d</td></tr>\n", $tmp[0], $tmp[0], $tmp[1], $tmp[2], $tmp[3], $tmp[4];
  $tabrow=$tabrow+1;
  $totday=$totday+$tmp[1];
}

################################################################
#  Display setup html and headings
################################################################

sub startup {
  print "Content-type: text/html\n\n";
  print "<body  bgcolor=\"#FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">\n";
  print "<center><font size=+2>Number of Days Report</font></center><br>\n";
  print "<hr><br>\n";
  print "<table border>\n";
  print "<tr><td>Ticket Number</td><td>Days Open</td><td>Ticket Owner</td><td>Submitter</td><td>Priority</td></tr>\n";
}
